'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var TIMELINE_HEIGHT = exports.TIMELINE_HEIGHT = '55px';
var MIN_TICK_SPACING_PX = exports.MIN_TICK_SPACING_PX = 70;
var MAX_TICK_SPACING_PX = exports.MAX_TICK_SPACING_PX = 415;
var FADE_OUT_FACTOR = exports.FADE_OUT_FACTOR = 1.4;
var TICKS_ROW_SPACING = exports.TICKS_ROW_SPACING = 16;
var MAX_TICK_ROWS = exports.MAX_TICK_ROWS = 3;
var MIN_RANGE_INTERVAL_PX = exports.MIN_RANGE_INTERVAL_PX = 4;

var TICK_SETTINGS_PER_PERIOD = exports.TICK_SETTINGS_PER_PERIOD = {
  year: {
    format: 'YYYY',
    childPeriod: 'month',
    periodIntervals: [1] // 1 year
  },
  month: {
    format: 'MMMM',
    parentPeriod: 'year',
    childPeriod: 'day',
    periodIntervals: [1, 3] // 1 month, 1 quarter
  },
  day: {
    format: 'Do',
    parentPeriod: 'month',
    childPeriod: 'minute',
    periodIntervals: [1, 7] // 1 day, 1 week
  },
  minute: {
    format: 'HH:mm',
    parentPeriod: 'day',
    periodIntervals: [1, 5, 15, 60, 180, 360] // 1min, 5min, 15min, 1h, 3h, 6h
  }
};